import { Node, Parent, Position, Point } from 'typed-unist';
import { RemarkParser } from './RemarkParser';
import { VFile } from 'typed-vfile';
export interface TokenizeMethod {
    (eat: Eat): Node | boolean | void;
    onlyAtStart?: boolean;
    notInList?: boolean;
    notInBlock?: boolean;
    notInLink?: boolean;
    locator?: (value: string, fromIndex?: number) => number;
}
export interface Eat {
    (subvalue: string): Apply;
    now: () => Point;
    file: VFile;
}
export interface Apply {
    (node: Node, parent?: Parent): Node;
    reset: Reset;
    test: Test;
}
export interface Reset {
    (node: Node, parent?: Parent): Node;
    test: Test;
}
export declare type Test = () => Position;
export interface Factory {
    (type: 'inline' | 'block'): Tokenize;
}
export interface Tokenize {
    (this: RemarkParser, value: string, location: Point): Node[];
}
export declare function factory(type: 'inline' | 'block'): (this: RemarkParser, value: string, location: Point) => Node[];
